/***************************************************************************
 * Copyright (c) 2007, Bart Cremers                                        *
 * All rights reserved.                                                    *
 *                                                                         *
 * Redistribution and  use in source  and binary  forms,  with or  without *
 * modification,  are permitted provided that the following conditions are *
 * met:                                                                    *
 *                                                                         *
 *   - Redistributions  of source  code  must retain  the above  copyright *
 *     notice, this list of conditions and the following disclaimer.       *
 *   - Redistributions in binary  form must reproduce  the above copyright *
 *     notice, this list of conditions and the following disclaimer in the *
 *     documentation   and/or   other    materials   provided   with   the *
 *     distribution.                                                       *
 *   - Neither  the  name  of  the  organization  nor  the  names  of  its *
 *     contributors  may be  used to  endorse or  promote products derived *
 *     from this software without specific prior written permission.       *
 *                                                                         *
 * THIS SOFTWARE  IS PROVIDED  BY THE COPYRIGHT  HOLDERS AND  CONTRIBUTORS *
 * "AS IS"  AND ANY  EXPRESS OR  IMPLIED WARRANTIES,  INCLUDING,  BUT  NOT *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
 * PARTICULAR  PURPOSE  ARE DISCLAIMED.  IN NO  EVENT SHALL  THE COPYRIGHT *
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,  INDIRECT,  INCIDENTAL, *
 * SPECIAL,  EXEMPLARY,  OR  CONSEQUENTIAL  DAMAGES  (INCLUDING,  BUT  NOT *
 * LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, *
 * DATA, OR PROFITS;  OR BUSINESS INTERRUPTION)  HOWEVER CAUSED AND ON ANY *
 * THEORY OF LIABILITY,  WHETHER IN CONTRACT,  STRICT  LIABILITY,  OR TORT *
 * (INCLUDING  NEGLIGENCE OR OTHERWISE)  ARISING IN ANY WAY OUT OF THE USE *
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 ***************************************************************************/
package net.sf.intelliplugin.visualgc.model;

/**
 * Constants used to retrieve specific info from the JVM.
 *
 * @author Bart Cremers
 * @since 20-nov-2007
 */
public interface Constants {

    String FINALIZER_QUEUE_LENGTH = "sun.gc.finalizer.queue.length";
    String FINALIZER_QUEUE_MAX_LENGTH = "sun.gc.finalizer.queue.maxLength";
    String FINALIZER_TIME = "sun.gc.finalizer.time";
    String FINALIZER_OBJECTS = "sun.gc.finalizer.objects";

    String NEW_GEN_MAX_SIZE = "sun.gc.generation.0.maxCapacity";
    String NEW_GEN_MIN_SIZE = "sun.gc.generation.0.minCapacity";
    String NEW_GEN_CURRENT_SIZE = "sun.gc.generation.0.capacity";
    String LAST_GC_CAUSE = "sun.gc.lastCause";
    String CURRENT_GC_CAUSE = "sun.gc.cause";
    String NEW_COLLECTOR_NAME = "sun.gc.collector.0.name";

    String SURVIVOR_FROM_SIZE = "sun.gc.generation.0.space.1.maxCapacity";
    String SURVIVOR_FROM_CAPACITY = "sun.gc.generation.0.space.1.capacity";
    String SURVIVOR_FROM_USED = "sun.gc.generation.0.space.1.used";

    String SURVIVOR_TO_SIZE = "sun.gc.generation.0.space.2.maxCapacity";
    String SURVIVOR_TO_CAPACITY = "sun.gc.generation.0.space.2.capacity";
    String SURVIVOR_TO_USED = "sun.gc.generation.0.space.2.used";

    String EDEN_SIZE = "sun.gc.generation.0.space.0.maxCapacity";
    String EDEN_CAPACITY = "sun.gc.generation.0.space.0.capacity";
    String EDEN_USED = "sun.gc.generation.0.space.0.used";

    String TENURED_SIZE = "sun.gc.generation.1.space.0.maxCapacity";
    String TENURED_CAPACITY = "sun.gc.generation.1.space.0.capacity";
    String TENURED_USED = "sun.gc.generation.1.space.0.used";

    String PERM_SIZE = "sun.gc.generation.2.space.0.maxCapacity";
    String PERM_CAPACITY = "sun.gc.generation.2.space.0.capacity";
    String PERM_USED = "sun.gc.generation.2.space.0.used";

    String EDEN_GC_EVENTS = "sun.gc.collector.0.invocations";
    String EDEN_GC_TIME = "sun.gc.collector.0.time";

    String TENURED_GC_EVENTS = "sun.gc.collector.1.invocations";
    String TENURED_GC_TIME = "sun.gc.collector.1.time";

    String AGETABLE_SIZE = "sun.gc.generation.0.agetable.size";

    String MAX_TENURING_THRESHOLD = "sun.gc.policy.maxTenuringThreshold";
    String TENURING_THRESHOLD = "sun.gc.policy.tenuringThreshold";

    String DESIRED_SURVIVOR_SIZE = "sun.gc.policy.desiredSurvivorSize";

    String AGETABLE_BYTES_PREFIX = "sun.gc.generation.0.agetable.bytes.";

    String CLASS_LOAD_TIME = "sun.cls.time";
    String CLASSES_LOADED = "java.cls.loadedClasses";
    String CLASSES_UNLOADED = "java.cls.unloadedClasses";
    String CLASS_BYTES_LOADED = "sun.cls.loadedBytes";
    String CLASS_BYTES_UNLOADED = "sun.cls.unloadedBytes";

    String TOTAL_COMPILE_TIME = "java.ci.totalTime";
    String TOTAL_COMPILE = "sun.ci.totalCompiles";

    String OS_ELAPSED_TIME = "sun.os.hrt.ticks";
    String OS_FREQUENCY = "sun.os.hrt.frequency";

    String JAVA_COMMAND = "sun.rt.javaCommand";
    String JAVA_HOME = "java.property.java.home";

    String VM_ARGS = "java.rt.vmArgs";
    String VM_FLAGS = "java.rt.vmFlags";
    String VM_INFO = "java.property.java.vm.info";
    String VM_NAME = "java.property.java.vm.name";
    String VM_VERSION = "java.property.java.vm.version";
    String VM_VENDOR = "java.property.java.vm.vendor";
    String VM_SPECIFICATION_NAME = "java.property.java.vm.specification.name";
    String VM_SPECIFICATION_VERSION = "java.property.java.vm.specification.version";
    String VM_SPECIFICATION_VENDOR = "java.property.java.vm.specification.vendor";

    String CLASS_PATH = "java.property.java.class.path";
    String BOOT_CLASS_PATH = "sun.property.sun.boot.class.path";
    String LIBRARY_PATH = "java.property.java.library.path";
    String BOOT_LIBRARY_PATH = "sun.property.sun.boot.library.path";
    String ENDORSED_DIRS = "java.property.java.endorsed.dirs";
    String EXT_DIRS = "java.property.java.ext.dirs";

    String LAST_MODIFICATION_TIME = "sun.perfdata.timestamp";
}
